import numpy as np
from .TS1 import TS1


def optimizer(data, data2, job_n, max_mach, overview, p):
    """
    : Local search
    """

    seq = p[0][0]
    sch = []
    mach = p[0][1]

    t = []
    for x in seq:
        if x not in t:
            sch.append((x, 1, mach[x-1][0]))
            t.append(x)
        else:
            t.append(x)
            m = t.count(x)
            sch.append((x, m, mach[x-1][m-1]))
    t = TS1(data, sch, overview, 7, 5, 20)
    schedule, _, ex_solutions = t.run()

    seq = [x[0] for x in schedule if x not in [(0, 0, 0), ('f', 'f', 'f')]]

    p[0][0] = seq
    p[0][1] = mach

    return p, ex_solutions
