import numpy as np
import random
from .TS2 import TS2


def mutation(overview, max_mach, data, data2, job_n, p):
    """
    : Mutation operator for the machine assignment
    : sequence and the operation sequence
    """

    seq = p[0][0]
    n = len(seq)
    smpl = np.random.choice(n, 2, replace=False)
    a = seq[smpl[1]]
    del seq[smpl[1]]
    seq.insert(smpl[0], a)
    p[0][0] = seq

    u = random.random()
    if u < 0.5:
        sch = []
        mach = p[0][1]
        t = []
        for x in seq:
            if x not in t:
                sch.append((x, 1, mach[x-1][0]))
                t.append(x)
            else:
                t.append(x)
                m = t.count(x)
                sch.append((x, m, mach[x-1][m-1]))
        t = TS2(max_mach, data, data2, sch, 3, 5, 20)
        a, b, _ = t.run()
        mach = []
        for i in range(1, job_n+1):
            mach.append([x[2] for x in a if x[0] == i])
    else:
        mach = p[0][1]
        n = len(mach)
        smpl = np.random.choice(n, 2, replace=False)
        a1 = mach[smpl[0]]
        b1 = mach[smpl[1]]
        c1 = np.random.randint(1, len(a1)+1)
        d1 = np.random.randint(1, len(b1)+1)
        m1 = random.choice(data2[(smpl[0]+1,c1)])
        m2 = random.choice(data2[(smpl[1]+1,d1)])
        mach[smpl[0]] = list(mach[smpl[0]])
        mach[smpl[1]] = list(mach[smpl[1]])
        mach[smpl[0]][c1-1] = m1
        mach[smpl[1]][d1-1] = m2
        mach[smpl[0]] = tuple(mach[smpl[0]])
        mach[smpl[1]] = tuple(mach[smpl[1]])
    p[0][1] = mach

    return p,
